libzmf::ZMF4Parser Class Reference documentation

Classes | Public Member Functions | Private Types | Private Member Functions | Static Private Member Functions | Private Attributes | List of all members
libzmf::ZMF4Parser Class Reference

`#include <ZMF4Parser.h>`

## Classes
struct | ObjectHeader
struct | ObjectRef

## Public Member Functions
| ZMF4Parser (const RVNGInputStreamPtr &input, librevenge::RVNGDrawingInterface *painter)
bool | parse ()

## Private Types
enum class | ObjectType { UNKNOWN , FILL , TRANSPARENCY , PEN , SHADOW , ARROW , FONT , PARAGRAPH , TEXT , BITMAP , PAGE_START , GUIDELINES , PAGE_END , LAYER_START , LAYER_END , DOCUMENT_SETTINGS , COLOR_PALETTE , RECTANGLE , ELLIPSE , POLYGON , CURVE , IMAGE , TEXT_FRAME , TABLE , GROUP_START , GROUP_END }

## Private Member Functions
| ZMF4Parser (const ZMF4Parser &other)=delete
ZMF4Parser & | operator= (const ZMF4Parser &other)=delete
ObjectHeader | readObjectHeader ()
std::vector< ObjectRef > | readObjectRefs ()
boost::optional< Fill > | getFillByRefId (uint32_t id)
boost::optional< Pen > | getPenByRefId (uint32_t id)
boost::optional< Shadow > | getShadowByRefId (uint32_t id)
boost::optional< Transparency > | getTransparencyByRefId (uint32_t id)
boost::optional< Font > | getFontByRefId (uint32_t id)
boost::optional< ParagraphStyle > | getParagraphStyleByRefId (uint32_t id)
boost::optional< Text > | getTextByRefId (uint32_t id)
boost::optional< Image > | getImageByRefId (uint32_t id)
ArrowPtr | getArrowByRefId (uint32_t id)
Style | readStyle ()
Point | readPoint ()
Point | readUnscaledPoint ()
BoundingBox | readBoundingBox ()
void | readCurveSectionTypes (std::vector< CurveType > &sectionTypes)
std::vector< Curve > | readCurveComponents (std::function< Point()> readPointFunc)
Color | readColor ()
Gradient | readGradient (uint32_t type)
void | readPreviewBitmap ()
void | readDocumentSettings ()
void | readPage ()
void | readLayer (const ObjectHeader &layerStartObjHeader)
void | readPen ()
void | readFill ()
void | readTransparency ()
void | readShadow ()
void | readArrow ()
void | readBitmap ()
void | readImage ()
void | readFont ()
void | readParagraphStyle ()
void | readText ()
void | readTextFrame ()
void | readCurve ()
void | readRectangle ()
void | readEllipse ()
void | readPolygon ()
void | readTable ()

## Static Private Member Functions
static ObjectType | parseObjectType (uint8_t type)

## Private Attributes
const RVNGInputStreamPtr | m_input
uint32_t | m_inputLength
ZMFCollector | m_collector
ZMF4Header | m_header
ZMFPageSettings | m_pageSettings
int | m_pageNumber
ObjectHeader | m_currentObjectHeader
std::map< uint32_t, Pen > | m_pens
std::map< uint32_t, Fill > | m_fills
std::map< uint32_t, Transparency > | m_transparencies
std::map< uint32_t, Shadow > | m_shadows
std::map< uint32_t, ArrowPtr > | m_arrows
std::map< uint32_t, Image > | m_images
std::map< uint32_t, Font > | m_fonts
std::map< uint32_t, ParagraphStyle > | m_paragraphStyles
std::map< uint32_t, Text > | m_texts

## Member Enumeration Documentation

## ◆ ObjectType

enum class libzmf::ZMF4Parser::ObjectType
| strongprivate

Enumerator
UNKNOWN |
FILL |
TRANSPARENCY |
PEN |
SHADOW |
ARROW |
FONT |
PARAGRAPH |
TEXT |
BITMAP |
PAGE_START |
GUIDELINES |
PAGE_END |
LAYER_START |
LAYER_END |
DOCUMENT_SETTINGS |
COLOR_PALETTE |
RECTANGLE |
ELLIPSE |
POLYGON |
CURVE |
IMAGE |
TEXT_FRAME |
TABLE |
GROUP_START |
GROUP_END |

## Constructor & Destructor Documentation

## ◆ ZMF4Parser() [1/2]

libzmf::ZMF4Parser::ZMF4Parser | ( | const ZMF4Parser & | other | ) |
| privatedelete

## ◆ ZMF4Parser() [2/2]

libzmf::ZMF4Parser::ZMF4Parser | ( | const RVNGInputStreamPtr & | input,
|  | librevenge::RVNGDrawingInterface * | painter
| ) |  |

## Member Function Documentation

## ◆ getArrowByRefId()

ArrowPtr libzmf::ZMF4Parser::getArrowByRefId | ( | uint32_t | id | ) |
| private

Referenced by readPen().

## ◆ getFillByRefId()

boost::optional< Fill > libzmf::ZMF4Parser::getFillByRefId | ( | uint32_t | id | ) |
| private

Referenced by readStyle(), and readTable().

## ◆ getFontByRefId()

boost::optional< Font > libzmf::ZMF4Parser::getFontByRefId | ( | uint32_t | id | ) |
| private

Referenced by readParagraphStyle(), and readText().

## ◆ getImageByRefId()

boost::optional< Image > libzmf::ZMF4Parser::getImageByRefId | ( | uint32_t | id | ) |
| private

Referenced by readFill(), and readImage().

## ◆ getParagraphStyleByRefId()

boost::optional< ParagraphStyle > libzmf::ZMF4Parser::getParagraphStyleByRefId | ( | uint32_t | id | ) |
| private

Referenced by readText().

## ◆ getPenByRefId()

boost::optional< Pen > libzmf::ZMF4Parser::getPenByRefId | ( | uint32_t | id | ) |
| private

Referenced by readStyle(), and readTable().

## ◆ getShadowByRefId()

boost::optional< Shadow > libzmf::ZMF4Parser::getShadowByRefId | ( | uint32_t | id | ) |
| private

Referenced by readStyle().

## ◆ getTextByRefId()

boost::optional< Text > libzmf::ZMF4Parser::getTextByRefId | ( | uint32_t | id | ) |
| private

Referenced by readTable(), and readTextFrame().

## ◆ getTransparencyByRefId()

boost::optional< Transparency > libzmf::ZMF4Parser::getTransparencyByRefId | ( | uint32_t | id | ) |
| private

Referenced by readStyle().

## ◆ operator=()

ZMF4Parser & libzmf::ZMF4Parser::operator= | ( | const ZMF4Parser & | other | ) |
| privatedelete

## ◆ parse()

bool libzmf::ZMF4Parser::parse | ( |  | ) |

## ◆ parseObjectType()

ZMF4Parser::ObjectType libzmf::ZMF4Parser::parseObjectType | ( | uint8_t | type | ) |
| staticprivate

Referenced by readObjectHeader().

## ◆ readArrow()

void libzmf::ZMF4Parser::readArrow | ( |  | ) |
| private

Referenced by readLayer().

## ◆ readBitmap()

void libzmf::ZMF4Parser::readBitmap | ( |  | ) |
| private

Referenced by readLayer().

## ◆ readBoundingBox()

BoundingBox libzmf::ZMF4Parser::readBoundingBox | ( |  | ) |
| private

Referenced by readEllipse(), readImage(), readPolygon(), readRectangle(), readTable(), and readTextFrame().

## ◆ readColor()

Color libzmf::ZMF4Parser::readColor | ( |  | ) |
| private

Referenced by readDocumentSettings(), readFill(), readGradient(), readPen(), readShadow(), and readTransparency().

## ◆ readCurve()

void libzmf::ZMF4Parser::readCurve | ( |  | ) |
| private

Referenced by readLayer().

## ◆ readCurveComponents()

std::vector< Curve > libzmf::ZMF4Parser::readCurveComponents | ( | std::function< Point()> | readPointFunc | ) |
| private

Referenced by readArrow(), and readCurve().

## ◆ readCurveSectionTypes()

void libzmf::ZMF4Parser::readCurveSectionTypes | ( | std::vector< CurveType > & | sectionTypes | ) |
| private

Referenced by readCurveComponents(), and readPolygon().

## ◆ readDocumentSettings()

void libzmf::ZMF4Parser::readDocumentSettings | ( |  | ) |
| private

Referenced by parse().

## ◆ readEllipse()

void libzmf::ZMF4Parser::readEllipse | ( |  | ) |
| private

Referenced by readLayer().

## ◆ readFill()

void libzmf::ZMF4Parser::readFill | ( |  | ) |
| private

Referenced by readLayer().

## ◆ readFont()

void libzmf::ZMF4Parser::readFont | ( |  | ) |
| private

Referenced by readLayer().

## ◆ readGradient()

Gradient libzmf::ZMF4Parser::readGradient | ( | uint32_t | type | ) |
| private

Referenced by readFill().

## ◆ readImage()

void libzmf::ZMF4Parser::readImage | ( |  | ) |
| private

Referenced by readLayer().

## ◆ readLayer()

void libzmf::ZMF4Parser::readLayer | ( | const ObjectHeader & | layerStartObjHeader | ) |
| private

Referenced by readPage().

## ◆ readObjectHeader()

ZMF4Parser::ObjectHeader libzmf::ZMF4Parser::readObjectHeader | ( |  | ) |
| private

Referenced by readDocumentSettings(), readLayer(), and readPage().

## ◆ readObjectRefs()

std::vector< ZMF4Parser::ObjectRef > libzmf::ZMF4Parser::readObjectRefs | ( |  | ) |
| private

Referenced by readFill(), readImage(), readParagraphStyle(), readPen(), readStyle(), and readTextFrame().

## ◆ readPage()

void libzmf::ZMF4Parser::readPage | ( |  | ) |
| private

Referenced by parse().

## ◆ readParagraphStyle()

void libzmf::ZMF4Parser::readParagraphStyle | ( |  | ) |
| private

Referenced by readLayer().

## ◆ readPen()

void libzmf::ZMF4Parser::readPen | ( |  | ) |
| private

Referenced by readLayer().

## ◆ readPoint()

Point libzmf::ZMF4Parser::readPoint | ( |  | ) |
| private

Referenced by readBoundingBox(), readCurve(), and readShadow().

## ◆ readPolygon()

void libzmf::ZMF4Parser::readPolygon | ( |  | ) |
| private

Referenced by readLayer().

## ◆ readPreviewBitmap()

void libzmf::ZMF4Parser::readPreviewBitmap | ( |  | ) |
| private

Referenced by parse().

## ◆ readRectangle()

void libzmf::ZMF4Parser::readRectangle | ( |  | ) |
| private

Referenced by readLayer().

## ◆ readShadow()

void libzmf::ZMF4Parser::readShadow | ( |  | ) |
| private

Referenced by readLayer().

## ◆ readStyle()

Style libzmf::ZMF4Parser::readStyle | ( |  | ) |
| private

Referenced by readCurve(), readEllipse(), readFont(), readImage(), readPolygon(), readRectangle(), and readTable().

## ◆ readTable()

void libzmf::ZMF4Parser::readTable | ( |  | ) |
| private

Referenced by readLayer().

## ◆ readText()

void libzmf::ZMF4Parser::readText | ( |  | ) |
| private

Referenced by readLayer().

## ◆ readTextFrame()

void libzmf::ZMF4Parser::readTextFrame | ( |  | ) |
| private

Referenced by readLayer().

## ◆ readTransparency()

void libzmf::ZMF4Parser::readTransparency | ( |  | ) |
| private

Referenced by readLayer().

## ◆ readUnscaledPoint()

Point libzmf::ZMF4Parser::readUnscaledPoint | ( |  | ) |
| private

Referenced by readArrow(), and readPolygon().

## Member Data Documentation

## ◆ m_arrows

std::map<uint32_t, ArrowPtr> libzmf::ZMF4Parser::m_arrows
| private

Referenced by getArrowByRefId(), and readArrow().

## ◆ m_collector

ZMFCollector libzmf::ZMF4Parser::m_collector
| private

Referenced by parse(), readBoundingBox(), readCurve(), readEllipse(), readImage(), readLayer(), readPage(), readPolygon(), readRectangle(), readTable(), and readTextFrame().

## ◆ m_currentObjectHeader

ObjectHeader libzmf::ZMF4Parser::m_currentObjectHeader
| private

Referenced by readArrow(), readBitmap(), readFill(), readFont(), readGradient(), readLayer(), readObjectRefs(), readParagraphStyle(), readPen(), readPolygon(), readShadow(), readText(), and readTransparency().

## ◆ m_fills

std::map<uint32_t, Fill> libzmf::ZMF4Parser::m_fills
| private

Referenced by getFillByRefId(), readFill(), and ZMF4Parser().

## ◆ m_fonts

std::map<uint32_t, Font> libzmf::ZMF4Parser::m_fonts
| private

Referenced by getFontByRefId(), and readFont().

## ◆ m_header

ZMF4Header libzmf::ZMF4Parser::m_header
| private

Referenced by parse().

## ◆ m_images

std::map<uint32_t, Image> libzmf::ZMF4Parser::m_images
| private

Referenced by getImageByRefId(), and readBitmap().

## ◆ m_input

const RVNGInputStreamPtr libzmf::ZMF4Parser::m_input
| private

Referenced by parse(), readArrow(), readBitmap(), readBoundingBox(), readColor(), readCurve(), readCurveComponents(), readCurveSectionTypes(), readDocumentSettings(), readEllipse(), readFill(), readFont(), readGradient(), readLayer(), readObjectHeader(), readObjectRefs(), readPage(), readParagraphStyle(), readPen(), readPoint(), readPolygon(), readPreviewBitmap(), readShadow(), readTable(), readText(), readTextFrame(), readTransparency(), and readUnscaledPoint().

## ◆ m_inputLength

uint32_t libzmf::ZMF4Parser::m_inputLength
| private

Referenced by parse(), and readObjectHeader().

## ◆ m_pageNumber

int libzmf::ZMF4Parser::m_pageNumber
| private

Referenced by readPage().

## ◆ m_pageSettings

ZMFPageSettings libzmf::ZMF4Parser::m_pageSettings
| private

Referenced by readDocumentSettings(), and readPage().

## ◆ m_paragraphStyles

std::map<uint32_t, ParagraphStyle> libzmf::ZMF4Parser::m_paragraphStyles
| private

Referenced by getParagraphStyleByRefId(), and readParagraphStyle().

## ◆ m_pens

std::map<uint32_t, Pen> libzmf::ZMF4Parser::m_pens
| private

Referenced by getPenByRefId(), readPen(), and ZMF4Parser().

## ◆ m_shadows

std::map<uint32_t, Shadow> libzmf::ZMF4Parser::m_shadows
| private

Referenced by getShadowByRefId(), and readShadow().

## ◆ m_texts

std::map<uint32_t, Text> libzmf::ZMF4Parser::m_texts
| private

Referenced by getTextByRefId(), and readText().

## ◆ m_transparencies

std::map<uint32_t, Transparency> libzmf::ZMF4Parser::m_transparencies
| private

Referenced by getTransparencyByRefId(), and readTransparency().

The documentation for this class was generated from the following files:

- ZMF4Parser.h
- ZMF4Parser.cpp